/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jan.23.2000  sprite demo

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ

  -- ˥塼Υƥ
  RRMainPetal
  RRMainPosition
  RRMainMessage
-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <gtk/gtk.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_spriteman.h"

#include  "../picture/cherry.xpm"
#include  "../picture/font_flame.xpm"
#include  "../picture/spr2_1.xpm"
#include  "../picture/spr2_2.xpm"
#include  "../picture/spr2_bk.xpm"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define    INTERVAL  20
#define    PETALMAX  100

static gint mes_pos_table[21] = {
  140, 130, 125, 115, 105, 95, 85, 75, 65, 55,
  45, 34, 25, 18, 12, 7, 4, 2, 1, 0, 0
};

/* --- ֤Ӥ¤ */
typedef struct _PetalObj PetalObj;
struct _PetalObj
{
  RRSObj     *o;              /* ɽ֥ */
  gfloat      x, y, z;        /* 3Dɸ */
  gfloat      r, sp;          /* ž® */
  gfloat      f;              /* 餮 */
};

/* --- å (󥵥ץʤľǤ) */
const gchar  *mes_str[5] = {
  "濫줤͡",
  "ͤġäѤʤǤʤ",
  "֤ߤޤФΤˡäƻפäƤ",
  "դդդ",
  "ͤϺڤϡġҤߤĤ"
};

/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- åܡɥꥢ */
void mes_clear(void);

/* --- ɸѴ */
gint  easy_geometry(float, float);

/* --- ֤Ӥɽ */
void  disp_petal(void);

/* --- åδɽ */
void  message_manage(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/*--- local timer */
static gint timer, lap;
static time_t segment;

/* --- åѥ */
static gint mes_timer;
static gint mes_step;

/* --- ǥץ쥤ݻ */
static gint  fw, fh;

/* --- ѿ */
static gint  int_handle;
static gint  petal_max;

/* --- Ωֻ */
static gint  pos_now, pos_target;

/* --- åɥֻ */
static gint  mes_now, mes_target;

/* --- ץ饤ȥե졼Хåե */
static GdkPixmap  *petal_pix, *chr1_pix, *chr2_pix, *backpix;
static GdkPixmap  *font_area, *mes_pix;
static GdkBitmap  *petal_mask, *chr1_mask, *chr2_mask;

/* --- ץ饤ȥ */
static RRSObj     *bg;
static RRSObj     *linaobj[2], *messageobj;

/* --- ֤Ӥδ */
static PetalObj   pt[PETALMAX];

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  GtkWidget *sc;
  GtkStyle  *style;
  gint i;
  gchar fontset[256];

  timer = 0;
  lap = 0;
  petal_max = 10;
  int_handle = 0;
  segment = time(NULL);
  mes_now = mes_target = 20;
  pos_now = pos_target = 0;
  mes_step = 0;

  srand((unsigned int)time(NULL));

  /* --- ꥽ˤäƻꤵƤ(Τ)
         եȤWidgetȴ */
  sc = RRScreenCanvas();
  style = gtk_rc_get_style(sc);
  sprintf(fontset, "%s,%s",
	  style->rc_style->font_name, style->rc_style->fontset_name);
  RRScreenFontSetInit(fontset);

  /* -- ߳ */
  int_handle = gtk_timeout_add(1000/INTERVAL, (GtkFunction)RRMain, NULL);

  /* -- եå pixmap  */
  petal_pix = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					   &petal_mask,
					   NULL,
					   cherry_xpm);

  backpix = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					 NULL,
					 NULL,
					 spr2_bk_xpm);

  chr1_pix = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					  &chr1_mask,
					  NULL,
					  spr2_1_xpm);

  chr2_pix = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					  &chr2_mask,
					  NULL,
					  spr2_2_xpm);

  font_area = gdk_pixmap_create_from_xpm_d(RRScreenWindow()->window,
					   NULL,
					   NULL,
					   font_flame_xpm);

  mes_pix = gdk_pixmap_new(RRScreenWindow()->window,
			   500, 100, -1);

  /* -- ֥ */
  RRSpritemanInit();
  RRSpritemanBGColor(0x0000, 0x0000, 0x6000);

  /* - ط */
  bg = RRSpritemanBGNew();
  bg->obj.sw = TRUE;
  bg->obj.mask_offset = TRUE;
  bg->obj.objmap = backpix;
  bg->obj.objmask = NULL;
  bg->obj.x = bg->obj.y = 0;
  bg->obj.w = 800;
  bg->obj.h = 480;
  bg->obj.ox = bg->obj.oy = 0;
  bg->obj.offset_x = bg->obj.offset_y = 0;
  bg->z = 400;
  /* - åɽ */
  mes_clear();
  messageobj = RRSpritemanNew();
  messageobj->obj.sw = TRUE;
  messageobj->obj.mask_offset = TRUE;
  messageobj->obj.objmap = mes_pix;
  messageobj->obj.objmask = NULL;
  messageobj->obj.x = 0;
  messageobj->obj.y = 500;
  messageobj->obj.w = 500;
  messageobj->obj.h = 100;
  messageobj->obj.ox = messageobj->obj.oy = 0;
  messageobj->obj.offset_x = messageobj->obj.offset_y = 0;
  messageobj->z = 0;
  /* - ʤ */
  linaobj[0] = RRSpritemanNew();
  linaobj[0]->obj.sw = TRUE;
  linaobj[0]->obj.mask_offset = TRUE;
  linaobj[0]->obj.objmap = chr1_pix;
  linaobj[0]->obj.objmask = chr1_mask;
  linaobj[0]->obj.x = 450;
  linaobj[0]->obj.y = 30;
  linaobj[0]->obj.w = 320;
  linaobj[0]->obj.h = 300;
  linaobj[0]->obj.ox = linaobj[0]->obj.oy = 0;
  linaobj[0]->obj.offset_x = linaobj[0]->obj.offset_y = 0;
  linaobj[0]->z = 150;
  linaobj[1] = RRSpritemanNew();
  linaobj[1]->obj.sw = TRUE;
  linaobj[1]->obj.mask_offset = TRUE;
  linaobj[1]->obj.objmap = chr1_pix;
  linaobj[1]->obj.objmask = chr1_mask;
  linaobj[1]->obj.x = 450;
  linaobj[1]->obj.y = 30 + 300;
  linaobj[1]->obj.w = 320;
  linaobj[1]->obj.h = 150;
  linaobj[1]->obj.ox = 0;
  linaobj[1]->obj.oy = 300;
  linaobj[1]->obj.offset_x = 0;
  linaobj[1]->obj.offset_y = 0;
  linaobj[1]->z = 150;
  /* - ֤Ӥ */
  for(i=0; i<PETALMAX; i++) {
    pt[i].o = NULL;
  }
  RRMainPetal(10);

}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (petal_pix != NULL) gdk_pixmap_unref(petal_pix);
  if (petal_mask != NULL) gdk_bitmap_unref(petal_mask);
  if (backpix != NULL) gdk_pixmap_unref(backpix);
  if (chr1_pix != NULL) gdk_pixmap_unref(chr1_pix);
  if (chr1_mask != NULL) gdk_bitmap_unref(chr1_mask);
  if (chr2_pix != NULL) gdk_pixmap_unref(chr2_pix);
  if (chr2_mask != NULL) gdk_bitmap_unref(chr2_mask);
  if (font_area != NULL) gdk_pixmap_unref(font_area);
  if (mes_pix != NULL) gdk_pixmap_unref(mes_pix);
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  fw = w;
  fh = h;
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  GtkStatusbar *stat;
  gchar tmp[128], info[128];

  timer++;
  lap++;
  if (segment != time(NULL)) {
    segment = time(NULL);
    /* --- StatusBar ˾ɽ */
    stat = GTK_STATUSBAR(RRGetParts(RRGetParts(RRScreenWindow(), "vbox1"), "statusbar1"));
    sprintf(info, "frame %d/Sec.", lap);
    gtk_statusbar_push(stat, gtk_statusbar_get_context_id(stat, tmp), info);
    lap = 0;
  }

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  /* --- ե졼 */
  if (pos_now < pos_target) pos_now++;
  if (pos_now > pos_target) pos_now--;
  if (mes_now < mes_target) mes_now++;
  if (mes_now > mes_target) mes_now--;

  /* --- åܡɤΰ */
  messageobj->obj.x = 70;
  messageobj->obj.y = 370 + mes_pos_table[mes_now];

  /* --- ʤΰ */
  linaobj[0]->obj.x = (320 - 148) - 
    easy_geometry((gfloat)(225.0 * (pos_now - 20) / 20),
		  (gfloat)linaobj[0]->z);
  linaobj[1]->obj.x = linaobj[0]->obj.x;

  /* --- طʤΰ */
  bg->obj.x = -120 - easy_geometry((gfloat)(80.0 * (pos_now - 20) / 20),
				  (gfloat)bg->z);

  /* --- ֤Ӥɽ */
  disp_petal();

  /* --- å */
  message_manage();

  /* --- ֥ */
  RRSpritemanAutoUpdate(0);

  return 1;
}


/* -------------------------------------------------------------
    --- Ƽɽ֥롼
-------------------------------------------------------------- */

/* ----------------------------------------------
  åܡɤξõ
------------------------------------------------- */
void mes_clear(void)
{
  GdkGC  *gc;
 
  gc = gdk_gc_new(mes_pix);
  gdk_gc_set_clip_mask(gc, NULL);
  gdk_gc_set_clip_origin(gc, 0, 0);
  gdk_draw_pixmap(mes_pix, gc, font_area, 0, 0, 0, 0, 500, 100);
  gdk_gc_destroy(gc);
}

/* ----------------------------------------------
  x (or y) 3Dɸ -> x 2Dɸ
------------------------------------------------- */
gint  easy_geometry(gfloat x, gfloat z)
{
  gfloat  ans;

  ans = x * 100 / z;
  return((gint) ans);
}

/* ----------------------------------------------
  ֤ӤɽȰư
------------------------------------------------- */
void  disp_petal(void)
{
  gint i, p;

  for(i=0; i<petal_max; i++) {
    if (pt[i].o != NULL) {
      /* --- ư */
      pt[i].x -= 0.2;
      pt[i].y += 1.0;
      if (pt[i].y > 100.0) {
	/* - Ϥ߽ФΤǤޤ夫 */
	pt[i].x = (gfloat)((200.0*rand()/(RAND_MAX+1.0)) - 100.0);
	pt[i].y = (gfloat)(-100.0);
	pt[i].z = (gfloat)((200.0*rand()/(RAND_MAX+1.0)) - 100.0);
	pt[i].r = 0.0;
	pt[i].f = 0.0;
	pt[i].sp = (gfloat)(100.0*rand()/(RAND_MAX+1.0)); 
	if (pt[i].o->z > 200) {
	  pt[i].o->obj.oy = 16;
	  pt[i].o->obj.w  = 8;
	  pt[i].o->obj.h  = 8;
	}
	else {
	  pt[i].o->obj.oy = 0;
	  pt[i].o->obj.w  = 16;
	  pt[i].o->obj.h  = 16;
	}
      }
      /* - 뤯񤦤 */
      pt[i].r += pt[i].sp;
      pt[i].f += pt[i].sp;
      if (pt[i].r > 400.0) {
	pt[i].r = 0;
      }
      p = (gint)(pt[i].r / 100.0);
      pt[i].o->obj.ox = 16 * p;

      /* --- ɽ */
      pt[i].o->obj.x = 320 + 80 + easy_geometry((pt[i].x - (gfloat)(pos_now - 20)) * 6,
						(gfloat)pt[i].o->z);

      pt[i].o->obj.x += (gint)(sin((pt[i].f * (2 * M_PI)) / 5000.0) * 8.0);
      pt[i].o->obj.y = 240 + easy_geometry(pt[i].y * 6, (gfloat)pt[i].o->z);
    }
  }
}

/* ----------------------------------------------
  åδɽ
------------------------------------------------- */
void  message_manage(void)
{
  gint r;

  switch(mes_step) {
  case 0:
    /* ---  */
    mes_timer = INTERVAL * 3 + INTERVAL * (10.0*rand()/(RAND_MAX+1.0));
    mes_step = 1;
    break;

  case 1:
    /* ---  */
    if (--mes_timer <= 0) {
      /* - åɽ */
      r = (gint)(5.0*rand()/(RAND_MAX+1.0));
      RRScreenGCColor(0x0000, 0x0000, 0x0000);
      RRScreenFontLocate(13, 13);
      RRScreenFontPrintDirect(mes_pix, mes_str[r]);
      RRScreenGCColor(0xf000, 0xf000, 0xf000);
      RRScreenFontLocate(12, 12);
      RRScreenFontPrintDirect(mes_pix, mes_str[r]);
      linaobj[0]->obj.objmap = chr2_pix;
      linaobj[0]->obj.objmask = chr2_mask;
      linaobj[1]->obj.objmap = chr2_pix;
      linaobj[1]->obj.objmask = chr2_mask;
      mes_timer = INTERVAL * 5;
      mes_step = 2;
    }
    break;

  case 2:
    /* --- ɽ */
    if (--mes_timer <= 0) {
      /* - åä */
      mes_clear();
      linaobj[0]->obj.objmap = chr1_pix;
      linaobj[0]->obj.objmask = chr1_mask;
      linaobj[1]->obj.objmap = chr1_pix;
      linaobj[1]->obj.objmask = chr1_mask;
      mes_step = 0;
    }
    break;

  }
}


/* -------------------------------------------------------------
    --- ˥塼μ
-------------------------------------------------------------- */

/* ----------------------------------------------
  ֤Ӥο
------------------------------------------------- */
void RRMainPetal(gint n)
{
  gint i;

  bg->update = TRUE;
  for(i=0; i<petal_max; i++) {
    if (pt[i].o != NULL) {
      RRSpritemanDestroy(pt[i].o);
    }
  }
  petal_max = n;
  for(i=0; i<petal_max; i++) {
    pt[i].o = RRSpritemanNew();
    /* --- ͽ */
    pt[i].x = (gfloat)((200.0*rand()/(RAND_MAX+1.0)) - 100.0);
    pt[i].y = (gfloat)((200.0*rand()/(RAND_MAX+1.0)) - 100.0);
    pt[i].z = (gfloat)((200.0*rand()/(RAND_MAX+1.0)) - 100.0);
    pt[i].r = 0.0;
    pt[i].f = 0.0;
    pt[i].sp = (gfloat)(100.0*rand()/(RAND_MAX+1.0)); 
    /* --- ֥ */
    pt[i].o->obj.sw = TRUE;
    pt[i].o->obj.mask_offset = TRUE;
    pt[i].o->obj.objmap = petal_pix;
    pt[i].o->obj.objmask = petal_mask;
    pt[i].o->obj.x = 0;
    pt[i].o->obj.y = 0;
    pt[i].o->obj.w = 16;
    pt[i].o->obj.h = 16;
    pt[i].o->obj.ox = pt[i].o->obj.oy = 0;
    pt[i].o->obj.offset_x = pt[i].o->obj.offset_y = 0;
    pt[i].o->z = (gint)(pt[i].z + 150.0);
    if (pt[i].o->z > 200) {
      pt[i].o->obj.oy = 16;
      pt[i].o->obj.w  = 8;
      pt[i].o->obj.h  = 8;
    }
    else {
      pt[i].o->obj.oy = 0;
      pt[i].o->obj.w  = 16;
      pt[i].o->obj.h  = 16;
    }
  }
}

/* ----------------------------------------------
  ư
------------------------------------------------- */
void RRMainPosition(gint n)
{
  pos_target = 40 * n;
}

/* ----------------------------------------------
  åɥ
------------------------------------------------- */
void RRMainMessage(gint n)
{
  mes_target = 20 * n;
}



